<template>
<div class="info">
 <div class="swiper">
      <swiper 
      style="height:1020rpx;width:100%;" 
      class="swiper" 
      indicator-dots="true"
      indicator-color="#A0A0A0"
      indicator-active-color="#333"  
      circular ="true" 
      :current="current"
      :autoplay="autoplay" 
      interval="5000" 
      duration="1000">
        <block v-for="(item, index) in imgUrls" :index="index" :key="index">
          <swiper-item>
            <div class="goods-images">
                <image :src="item" :index="index" class="slide-image" mode="aspectFit"/>          
            </div> 
          </swiper-item>
        </block>
      </swiper>
 </div>
 <div class="content">
   <div class="content-header">
      <div class="goods-name">{{datas.productName}}</div>
      <div class="integral">
        <span class="integral-title">积分:</span>
        <span class="integral-num">{{datas.exchangePoints}}</span>
      </div>
   </div>
    <div class="detail">
      <div class="cell" @click="showDetailInfo=!showDetailInfo">
        <span class="detail-title">详情</span>
        <img class="icon-plus" src="../../../../static/images/plus.png" v-if="!showDetailInfo" alt="">
        <img class="icon-plus" src="../../../../static/images/jianhao.png" v-if="showDetailInfo" alt="" >
      </div>
      <div :class="[showDetailInfo?'show-detail':'detail-info']" >
        <rich-text class="rich-text" :nodes="datas.description"></rich-text>  
        <img src="https://pic.8848phone.com/custom/8848/image/pic-login-header.png" alt="">
      </div>
    </div>
    <div class="goods-base-info" >
      <div class="color-cell"  v-if="datas.exchangeType==='product'">
        <span class="color-title">颜色</span>
        <div class="color-list"> 
          <div 
          :class="[goodsInfo.color===item.color?'color-item-active':'','color-item']" 
          v-for="(item,index) in datas.colorImage" 
          :key="index" 
          @click="event().selectColor(item)"
          >
            <span class="color-text">{{item.color}}</span>
            <div class="color-img">
              <img style="width:100%;height:100%" :src="item.image" alt="">
            </div>
          </div>
        </div>
      </div>
      <div class="size-cell" v-if="datas.exchangeType==='product'&&sizeList.length>0">
        <span class="size-title">尺码</span>
        <div class="size-list">
          <div 
          :class="[goodsInfo.size===item?'size-item-active':'','size-item']" 
          v-for="(item,index) in sizeList" 
          :key="index"
          @click="goodsInfo.size = item"
          >
            <span class="size-text">{{item}}</span>
          </div>
        </div>
      </div>
      <div class="amount-cell">
        <span class="amount-title">数量</span>
        <div class="amount-operation">
          <img class="icon-plus" src="../../../../static/images/jianhao.png" alt="" @click="event().reduce()">
          <input type="number" :min="0" v-model="goodsInfo.count">
          <img class="icon-plus" src="../../../../static/images/plus.png" alt="" @click="event().increase()">
        </div>
      </div>
    </div>
 </div>
 <div style="padding:30rpx 0;">
    <v-footer  :footer="'立即兑换'" @footerEmit="event().toChange()"></v-footer>
 </div>
<v-hintbox :hintbox="hintbox" @close="close"></v-hintbox>
</div>
</template>

<script type="text/ecmascript-6">
  import config from '@/config'
  import {VeevlinkLogin,VeevlinkIslogin,VeevlinkClient,VeevlinkData} from '@/utils/base'
  import {get,showToast,setStorageSync,getStorageSync,scanCode} from '@/util'
  import hintbox from '@/components/hintbox/hintbox.vue'
  import footer from '@/components/footer/footer.vue'
  import {mapMutations} from 'vuex';
  export default {
    data(){
      return{
        datas:{},
        autoplay:true,
        current:0,
        sizeList:[],
        goodsInfo:{
          color:'',
          count:1,
          productId:'',
          exchangeType:'',
          size:null,
          memberId:'',
          image:'',
          exchangePoints:null,
          productName:''
        },
        showDetailInfo:false,
        productId:'',
        num:0,
        imgUrls: [
        ],
        
      }
    },
    components:{
       'v-hintbox' : hintbox,
       'v-footer' : footer
    },
    methods:{
      ...mapMutations(['SAVE_GOODSINFO']),
    /*  =====自定义函数/方法区start===== */
    handler() {
      return {
        //todo:替换url,赶时间。。先不公用化了
        replaceUrl: (domain, url) => {
          //删除url原有域名
          const DeleteDomainUrl = url.substring(
            url.indexOf(".com/") + 4,
            url.length
          );
          //转码
          const normalUrl = DeleteDomainUrl.replace(/&amp;/g, "&");
          return domain + normalUrl;
        }
      };
    },
    /*  =====自定义函数/方法区end===== */

 /* ======事件区start======= */
    event() {
      return {
        //todo:减少商品数量
        reduce:()=>{
          if(this.goodsInfo.count>1){
            this.goodsInfo.count--
          }
        },
        //todo:买买买
        increase:()=>{
            this.goodsInfo.count++
        },
        //todo:土豪赶紧兑换吧 = =
        toChange:()=>{
          if(this.goodsInfo.exchangeType==='product'){
            if(this.goodsInfo.color){
              if(this.goodsInfo.size){
                 this.SAVE_GOODSINFO(this.goodsInfo)
                config.href(config.shop.confirm);
              }else{
                wx.showToast({
                  title: '请选择产品尺码', //提示的内容,
                  icon: 'none', //图标,
                  duration: 1000, //延迟时间,
                  success: res => {}
               });
              }
            }else{
              wx.showToast({
                title: '请选择产品颜色', //提示的内容,
                icon: 'none', //图标,
                duration: 1000, //延迟时间,
                success: res => {}
              });
            }
          }else{
              this.SAVE_GOODSINFO(this.goodsInfo)
              config.href(config.shop.confirm);
          }
          
          // wx.setStorageSync('goodsInfo',JSON.stringify(this.goodsInfo));
          
        },
        selectColor:(item)=>{
          this.goodsInfo.size = ''
          this.autoplay	= false
          this.imgUrls.forEach((img,index)=>{
            if(img===item.image){
              this.current = index
            }
          })
          this.sizeList = item.size
          this.goodsInfo.color=item.color
          this.goodsInfo.image = item.image

        }
      };
    },
    /* ======事件区end======= */   

    /* =======网络请求区start======= */
    network(){
      return{
        runApiToGetDetail:(data)=>{
        let VerificationCodeEntity =  wx.getStorageSync('informationwx23bcedfe9e867c13');
        VeevlinkClient(
          '/points/product/info?openId=' + VerificationCodeEntity.OpenId +'&productId='+data.productId+'&type='+data.type,
          'GET',
          '',
          data=> {
            if(data.success){
              this.imgUrls = []
              data.records[0].colorImage.forEach((item,index)=>{
                item.image = this.handler().replaceUrl("http://redstone-uat-site.veevlink.com",item.image)
                // if(index===0){
                //   this.goodsInfo.color = item.color
                //   this.goodsInfo.image = item.image
                // }
              })
              data.records[0].carouselPictures.forEach(item=>{
                this.imgUrls.push(this.handler().replaceUrl("http://redstone-uat-site.veevlink.com",item))
              })
              // this.goodsInfo.size = data.records[0].size[0]
              this.goodsInfo.exchangePoints = data.records[0].exchangePoints
              this.goodsInfo.productName = data.records[0].productName
              this.datas = data.records[0];
            console.log('详情',this.datas);
            }else{
              wx.showToast({
                title: success.message, //提示的内容,
                icon: 'none', //图标,
                duration: 2000, //延迟时间,
                // mask: true, //显示透明蒙层，防止触摸穿透,
                // success: res => {}
              });
            }
          },
          error=>{
            console.log(error);
          })
        },
      }
    },
    },
    //分享朋友
      onShareAppMessage:function(options){
           console.log('分享');
        　　var that = this;
        　　// 设置菜单中的转发按钮触发转发事件时的转发内容
        　　var shareObj = {
        　　　　title: "转发的标题",        // 默认是小程序的名称(可以写slogan等)
        　　　　path: '/pages/shop/detail/main',        // 默认是当前页面，必须是以‘/’开头的完整路径
        　　　　imgUrl: 'https://pic.8848phone.com/custom/8848/image/pic-login-header.png',     //自定义图片路径，可以是本地文件路径、代码包文件路径或者网络图片路径，支持PNG及JPG，不传入 imageUrl 则使用默认截图。显示图片长宽比是 5:4
        　　　　success: function(res){
                  console.log('成功',res);
        　　　　　　// 转发成功之后的回调
        　　　　　　if(res.errMsg == 'shareAppMessage:ok'){
        　　　　　　}
        　　　　},
        　　　　fail: function(res){
        　　　　　　// 转发失败之后的回调
                  console.log('成功',res);
        　　　　　　if(res.errMsg == 'shareAppMessage:fail cancel'){
        　　　　　　　　// 用户取消转发
        　　　　　　}else if(res.errMsg == 'shareAppMessage:fail'){
        　　　　　　　　// 转发失败，其中 detail message 为详细失败信息
        　　　　　　}
        　　　　},
        　　　　complete(res){
        　　　　　　// 转发结束之后的回调（转发成不成功都会执行）
                  console.log('完成',);
        　　　　}
        　　};
        　　// 来自页面内的按钮的转发
        　　if( options.from == 'button' ){
        　　　　var eData = options.target.dataset;
        　　　　console.log(eData);     // shareBtn
        　　　　// 此处可以修改 shareObj 中的内容
        　　　　shareObj.path = '/pages/btnname/btnname?btn_name='+eData.name;
        　　}
        　　// 返回shareObj
        　　return shareObj;
        },
    onLoad(data){
      this.goodsInfo.productId = data.productId;
      this.goodsInfo.exchangeType = data.type
      this.goodsInfo.memberId = wx.getStorageSync('memberid')
      this.network().runApiToGetDetail(data);
      
    }

  }
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style lang="scss" type="text/scss" scoped>
.icon-plus{
  height: 25rpx;
  width: 25rpx;
}
.info{
  .goods-images{
    height: 100%;
    background-color: #eee;
    display: flex;
    align-items: center;
    justify-content: center;
    .slide-image{
      width: 500rpx;
      height: 715rpx;
    }
  }
  .content{
    padding:70rpx;
    font-family:STXihei;
    color:#333;
    .content-header{
      margin-bottom:40rpx;
      .goods-name{
        margin-bottom:40rpx;
       font-size: 28rpx;
      }
      .integral{
      .integral-title{
        font-size: 24rpx;
        }
        .integral-num{
          font-size:24rpx;
          font-family:GillSans-Light,GillSans;
        }
      }
    }
    .detail{
      border-bottom:1rpx solid #D8D8D8;
      .cell{
        box-sizing: border-box;
        padding:40rpx 0;
        display: flex;
        justify-content: space-between;
        align-items: center;

      }
      .cell:first-child{
        border-top:1rpx solid #D8D8D8;
      }
      .detail-title{
        font-size:24rpx;
          font-family:STXihei;
          color:#333;
      }
      .detail-info{
        height: 0;
        transition:height .3s;
        overflow: hidden;
      }
      .show-detail{
        overflow: auto;
        transition:height .3s;
        height: 700rpx;
      }
      .rich-text{
        font-size:28rpx;
        line-height:38rpx;
        color:#727171;
        font-family:GillSans-Light,GillSans;

      }
    }
   .goods-base-info{
      .size-cell,.color-cell,.amount-cell{
         border-bottom: 1rpx solid #D8D8D8;
       }
       .amount-cell{
        //  border-bottom: 1rpx solid #D8D8D8;
         padding:34rpx 0 !important;
       }
       .color-cell{
         padding:23rpx 0 !important;
       }
       .size-cell{
         padding:30rpx 0 !important;
       }
     .color-cell,.size-cell,.amount-cell{
       display: flex;
       align-items: center;
       justify-content: space-between;
        padding:40rpx 0;
       .color-title,.size-title,.amount-title{
         font-size:24rpx;
          font-family:STXihei;
          color:#333;
       }
       .amount-operation{
         display: flex;
         align-items: center;
         justify-content: center;

         input{
           margin: 0 30rpx;
           width:44rpx;
           height:44rpx;
           line-height: 44rpx;
           text-align: center;
            // padding: 6rpx;
            box-sizing: border-box;
            font-size:22rpx;
            font-family:GillSans-Light,GillSans;
           border:1rpx solid rgba(0,0,0,0.4)
         }
       }

       .color-list,.size-list{
         width: 70%;
         display: flex;
         flex-wrap: wrap;
          .color-item,.size-item{
            display: flex;
            align-items: center;
            margin-right: 10rpx;
              .color-text,.size-text{
                margin-right: 30rpx;
                font-size:18rpx;
                font-family:STXihei;
                color:#333;
              }
              .size-text{
                box-sizing: border-box;
                border:1rpx solid transparent;
                padding:10rpx;
                font-size: 24rpx;
                font-family:GillSans-Light,GillSans;
              }
            .color-img{
              width:65rpx;
              height: 65rpx;
              padding:6rpx;
              box-sizing: border-box;
              border:1rpx solid #ccc;
            }
          }
          .color-item:nth-child(3n+0){
            margin-right: 0rpx;
          }
          .color-item-active{
            .color-img{
              border-color:#333
            }
          }
          .size-item-active{
            .size-text{
              border-color: #333;
            }
          }
       }
      
     }

     
   }
    
    // .cell:not(:last-child)::after {
    //     position: absolute;
    //     box-sizing: border-box;
    //     content: ' ';
    //     pointer-events: none;
    //     right: 0;
    //     bottom: 0;
    //     left: 16px;
    //     border-bottom: 1px solid #ebedf0;
    //     -webkit-transform: scaleY(0.5);
    //     transform: scaleY(0.5);
    // }
  }

}

</style>
